//
// Private fields, axioms for functions, and implementations of procedures
//

const unique ArrayList.count: <int>name;
const unique ArrayList.items: <[int]any>name;

// function ArrayList.INV(h: [ref, <x>name]x, o: ref) returns (bool);
// INV depends only on the things in its footprint
axiom
  (forall H: [ref, <x>name]x, o: ref
    :: { ArrayList.INV(H,o) }
      (
        IsGoodObject(o, H)
        && 0 <= H[o,ArrayList.count]
        && H[o,ArrayList.count] <= #ArrayList.size(H,o)
        && (forall p: ref :: H[o,ArrayList.footprint][p] <==> p == o)
      )
      <==>
      ArrayList.INV(H,o)
  );

// #ArrayList.size(h: [ref, <x>name]x, o: ref) returns (int);
axiom
  (forall h: [ref, <x>name]x, o: ref
    :: { #ArrayList.size(h,o) }
   IsGoodObject(o, h)
     ==>
   #ArrayList.size(h,o) == h[o,ArrayList.count]
  );

implementation ArrayList.Add(this: ref, o: any)
{
  var newValue : [int]any;
  assume (forall i: int ::
          (i != Heap[this,ArrayList.count] 
           ==> newValue[i] == Heap[this, ArrayList.items][i])
          &&
          (i == Heap[this,ArrayList.count] 
           ==> newValue[i] == o)
         );
  Heap[this, ArrayList.items] := newValue;
  assume IsGoodHeap(Heap);
  Heap[this,ArrayList.count] := Heap[this,ArrayList.count] + 1;
  assume IsGoodHeap(Heap);
}

// function #ArrayList.get(h: [ref, <x>name]x, o: ref, i : int) returns (any);
axiom
  (forall h: [ref, <x>name]x, o: ref, i: int
    :: { #ArrayList.get(h,o,i) }
   IsGoodObject(o, h) && 0 <= i && i < #ArrayList.size(h,o)
     ==>
   #ArrayList.get(h,o,i) == h[o,ArrayList.items][i]
  );

implementation ArrayList.Get(this: ref, index: int) returns (result: any)
{
  result := Heap[this, ArrayList.items][index];
}

