//
// Axioms for client view of functions
//

// function ArrayList.INV(h: [ref, <x>name]x, o: ref) returns (bool);
// INV depends only on the things in its footprint
axiom
  (forall H: [ref, <x>name]x, K: [ref, <x>name]x, o: ref
    :: { ArrayList.INV(H,o), ArrayList.INV(K,o) }

      (
        IsGoodObject(o, H) && IsGoodObject(o,K)
        && H[o,ArrayList.footprint] == K[o,ArrayList.footprint]
        && (forall p : ref, f: name ::
             IsGoodObject(p,H) && IsGoodObject(p,K) && H[o,ArrayList.footprint][p] 
             ==>  H[p,f] == K[p,f])
      )
      ==>
      ArrayList.INV(H,o) == ArrayList.INV(K,o)
  );
axiom
  (forall H: [ref, <x>name]x, o: ref
    :: { ArrayList.INV(H,o) }

      ArrayList.INV(H,o)
      ==>
      (forall p: ref :: H[o,ArrayList.footprint][p] ==> IsGoodObject(p,H))
  );

// #ArrayList.size(h: [ref, <x>name]x, o: ref) returns (int);
axiom
  (forall H: [ref, <x>name]x, K: [ref, <x>name]x, o: ref
    :: { #ArrayList.size(H,o), #ArrayList.size(K,o) }

      (
        IsGoodObject(o, H) && IsGoodObject(o,K)
        && H[o,ArrayList.footprint] == K[o,ArrayList.footprint]
        && (forall p : ref, f: name ::
             IsGoodObject(p,H) && IsGoodObject(p,K) && H[o,ArrayList.footprint][p] 
             ==>  H[p,f] == K[p,f])
      )
      ==>
      #ArrayList.size(H,o) == #ArrayList.size(K,o)
  );

// function #ArrayList.get(h: [ref, <x>name]x, o: ref, i: int) returns (any);
axiom
  (forall H: [ref, <x>name]x, K: [ref, <x>name]x, o: ref, i: int
    :: { #ArrayList.get(H,o,i), #ArrayList.get(K,o,i) }

      (
        IsGoodObject(o, H) && IsGoodObject(o,K)
        && H[o,ArrayList.footprint] == K[o,ArrayList.footprint]
        && (forall p : ref, f: name ::
             IsGoodObject(p,H) && IsGoodObject(p,K) && H[o,ArrayList.footprint][p] 
             ==>  H[p,f] == K[p,f])
      )
      ==>
      #ArrayList.get(H,o,i) == #ArrayList.get(K,o,i)
  );
