////////////////////////////////////////////////////////////////
// In the following client, sub0's observer is obs0 and sub1's observers 
// are obs1 and obs2; sub0 is first updated;*/
// Then obs2 is registered as sub1's observer. 
///////////////////////////////////////////////////////////////

procedure client()
    modifies $Heap;
    // user-declared postconditions
    // effects
  {   
        var sub0 : ref;
        var sub1 : ref;
        var obs0 : ref;
        var obs1 : ref;
        var obs2 : ref;
        var m    : int;
        var n    : int;
        var tmp  : int;

    //sub0 = new Subject();
        havoc sub0;
        assume !$Heap[sub0,alloc];
        call Subject..ctor(sub0);

    //obs0 = new Observer();
        havoc obs0;
        assume !$Heap[obs0,alloc];
        // this is here because we are not using a type system
        assume EqualSet($Heap[obs0, Subject.O],  EmptySet); 
        // obs0 is registered with sub0
        call Observer..ctor(obs0, sub0); 

    //sub1  = new Subject();
        havoc sub1;
        assume !$Heap[sub1,alloc];
        call Subject..ctor(sub1);

    //obs1 = new Observer();
        havoc obs1;
        assume !$Heap[obs1,alloc];
        assume EqualSet($Heap[obs1, Subject.O],  EmptySet);
        // obs1 is registered with sub1
        call Observer..ctor(obs1, sub1); 

    //obs2 = new Observer();
        havoc obs2;
        assume !$Heap[obs2,alloc];
        assume EqualSet($Heap[obs2, Subject.O],  EmptySet);
        // obs2 is registered with sub1
        call Observer..ctor(obs2, sub1); 

     tmp := $Heap[obs1, Observer.caches][sub0];
     call Subject.update(sub0, 5);
     assert $Heap[obs1, Observer.caches][sub0] == tmp;

     assert SubObs(sub0, 5, $Heap);

     assert $Heap[obs0, Observer.caches][sub0] == 5;

     assert SubObs(sub1, 0, $Heap);
     // now obs0 also starts observing sub1
     call Subject.register(sub1, obs0); 

     call m := Observer.val(obs0, sub1);

     assert m == 0;

     call n := Observer.val(obs0, sub0);

     assert n == 5;

  }
///////////////////////////////////////////////////////////////
// In the following client sub0's observers are obs0 and obs1; 
// sub1's observer is obs2; sub0 is updated         
//////////////////////////////////////////////////////////////
procedure client0()
    modifies $Heap;
    // user-declared postconditions
    // effects
  {   
        var sub0 : ref;
        var obs0 : ref;
        var obs1 : ref;
        var sub1 : ref;
        var obs2 : ref;
        var   n1 : int; 

    // sub0 = new Subject();
        havoc sub0;
        assume !$Heap[sub0,alloc];
        call Subject..ctor(sub0);

    // obs0 = new Observer();
        havoc obs0;
        assume !$Heap[obs0,alloc];
        assume EqualSet($Heap[obs0, Subject.O],  EmptySet);
        // obs0 is registered with sub0
        call Observer..ctor(obs0, sub0); 

    // obs1 = new Observer();
        havoc obs1;
        assume !$Heap[obs1,alloc];
        assume EqualSet($Heap[obs1, Subject.O],  EmptySet);
        // obs1 is registered with sub0
        call Observer..ctor(obs1, sub0); 

  //   sub1  = new Subject();
        havoc sub1;
        assume !$Heap[sub1,alloc];
        call Subject..ctor(sub1);

   //  obs2 = new Observer();
        havoc obs2;
        assume !$Heap[obs2,alloc];
        assume EqualSet($Heap[obs2, Subject.O],  EmptySet);
        // obs2 is registered with sub1
        call Observer..ctor(obs2, sub1); 
        
        call Subject.update(sub0, 5);

        assert SubObs(sub0, 5, $Heap);
        assert SubObs(sub1, 0, $Heap);

        call n1 := Observer.val(obs2, sub1);
        assert n1 == 0;
  }
