// List Reverse
// No allocation in list reverse
var $Heap: [ref, <x>name]x where IsGoodHeap($Heap);

// This is the "nxt" field of the class Node, used for linked lists.
const unique Node.nxt: <ref>name;

procedure ReverseInPlace(x: ref) returns ($result: ref)
    free requires IsGoodHeap($Heap);
    free requires x == null || IsGoodObject(x, $Heap);
    //following comments are the Region Logic preconditions
    // < is for subset
    //requires x in r && r.nxt < r;
    //ensures $result in r && r.nxt < r;
    //modifies [wr(r.nxt)]
    modifies $Heap;
    free ensures IsGoodHeap($Heap);
    free ensures NoDeallocs(old($Heap),$Heap);
  {
    var current : ref where current == null || IsGoodObject(current,$Heap);
    var y : ref;
    var tmp : ref;
    var r : [ref]bool;

    // simulate preconditions for things not visible outside of the method
    assume x == null || r[x];
    assume RegionClosure(r,$Heap,Node.nxt); // r.nxt < r
   
    current := x;
    y := null;
    while (current != null)
      //invariant x < r && y < r && r.nxt < r;
      invariant current == null || r[current]; 
      invariant y == null || r[y];
      invariant RegionClosure(r,$Heap,Node.nxt);
      invariant // wr r.nxt
       (forall p: ref, f: name :: 
          IsGoodObject(p,old($Heap)) ==>
          old($Heap[p,f]) == $Heap[p,f] || (r[p] && f == Node.nxt)
       );
   
    {
      tmp := $Heap[current,Node.nxt];
      $Heap[current,Node.nxt] := y;
      y := current;
      current := tmp;
    }
    $result := y;
    // simulate postconditions for things not visible outside of the method
    assert $result == null || r[$result];
    assert RegionClosure(r,$Heap,Node.nxt);
    // modifies wr(r.nxt)
    assert 
      (forall p: ref, f: name :: 
         IsGoodObject(p,old($Heap)) ==>
         old($Heap[p,f]) == $Heap[p,f] || (r[p] && f == Node.nxt)
      );

  }
